﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Threading.Tasks;
using System.Windows.Forms;
using NAudio.Wave;

namespace Capstone.Project
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }         
        
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //close the program
            this.Close();
        }

        private void buttonSnippetCreator_Click(object sender, EventArgs e)
        {
            snippetCreatorForm child = new snippetCreatorForm();
            child.ShowDialog();
        }

        private void buttonSentenceCreationV2_Click(object sender, EventArgs e)
        {
            SentenceCreation child = new SentenceCreation();
            child.ShowDialog();
        }

        private void snippetCreatorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            snippetCreatorForm child = new snippetCreatorForm();
            child.ShowDialog();
        }

        private void sentenceCreationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SentenceCreation child = new SentenceCreation();
            child.ShowDialog();
        }

        /*********************************************************
         *Function reformats all sound clips to the proper format.
         *********************************************************/ 
        private void cleanWavFormatsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                string SoundClipsLocation = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
                SoundClipsLocation += "\\SoundClipCollection\\";

                //fix files not assigned to a person
                string[] fileEntries = Directory.GetFiles(SoundClipsLocation);

                foreach (string fileName in fileEntries)
                {
                    WaveStream stream = new WaveFileReader(fileName);
                    WaveFormat testFormat = stream.WaveFormat;
                    stream.Close();

                    //converter
                    if (testFormat.Equals(CustomSoundClass.DefaultFormat) == false)
                    {
                        if (File.Exists("origFile.wav"))
                        {
                            File.Delete("origFile.wav");
                        }
                        File.Move(fileName, "origFile.wav");

                        stream = new WaveFileReader("origFile.wav");

                        WaveFormatConversionStream str = new WaveFormatConversionStream(CustomSoundClass.DefaultFormat, stream);

                        WaveFileWriter.CreateWaveFile(fileName, str);

                        stream.Close();
                        str.Close();

                        File.Delete("origFile.wav");
                    }
                }

                //fix files assigned to people
                string[] subdirectoryEntries = Directory.GetDirectories(SoundClipsLocation);

                foreach (string subdirectory in subdirectoryEntries)
                {
                    string[] subFiles = Directory.GetFiles(subdirectory);

                    foreach (string fileName in subFiles)
                    {
                        WaveStream stream = new WaveFileReader(fileName);
                        WaveFormat testFormat = stream.WaveFormat;
                        stream.Close();

                        //converter
                        if (testFormat.Equals(CustomSoundClass.DefaultFormat) == false)
                        {
                            if (File.Exists("origFile.wav"))
                            {
                                File.Delete("origFile.wav");
                            }
                            File.Move(fileName, "origFile.wav");

                            stream = new WaveFileReader("origFile.wav");

                            WaveFormatConversionStream str = new WaveFormatConversionStream(CustomSoundClass.DefaultFormat, stream);

                            WaveFileWriter.CreateWaveFile(fileName, str);

                            stream.Close();
                            str.Close();

                            File.Delete("origFile.wav");
                        }
                    }
                }


                MessageBox.Show("conversion completed successfully");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }                      
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            string SoundClipsLocation = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            SoundClipsLocation += "\\SoundClipCollection\\";

            if (Directory.Exists(SoundClipsLocation) == false)
            {
                Directory.CreateDirectory(SoundClipsLocation);
            }
        }
    }
}
